<script lang="ts">
	import {
		ArrowLeftIcon,
		FacebookIcon,
		InstagramIcon,
		MenuIcon,
		TwitterIcon
	} from 'svelte-feather-icons';
	import NavMenu from './NavMenu.svelte';
	import { page } from '$app/stores';
	import { navItems, smallScreen } from '../utils/const';
	import {
		scrollY,
		showMenu,
		showReturn,
		store_headerHeight,
		store_screenWidth
	} from '../utils/store';
	import { routeToPage } from '../utils/utils';
	import resolveConfig from 'tailwindcss/resolveConfig';
	import tailwindConfig from '../../tailwind.config.js';
	import Noel from './special/Noel.svelte';
	import { onMount } from 'svelte';

	export let headerHeight: number;

	$: currentPath = $page.url.pathname;

	let headerItems = navItems;
	$: if (currentPath) {
		headerItems = headerItems.map((item) => {
			if (item.link === currentPath) {
				item.active = true;
				item.iconParam.strokeWidth = 2;
			} else {
				item.active = false;
				item.iconParam.strokeWidth = 1;
			}
			return item;
		});
	}

	let openMenu: boolean = false;

	$: condition = $scrollY >= 100 || $showMenu;

	const PRIMARY: string = tailwindConfig.theme.colors.primary[500];

	let bg: string = PRIMARY;
	$: bg = condition ? PRIMARY : 'transparent';

	let opacity: string = '100';
	$: opacity = condition ? '100' : '10';

	let color: string = PRIMARY;
	$: color = condition ? 'black' : 'white';

	$: store_headerHeight.update((_) => headerHeight);

	let show = false;
	onMount(() => {
		setTimeout(() => {
			show = true;
		}, 1000);
	});
</script>

<div
	class="fixed top-0 left-0 w-full p-4 text-2xl grid md:grid-cols-3 grid-cols-2 bg-opacity-0"
	style={'background-color: ' +
		bg +
		';' +
		'color: ' +
		color +
		';' +
		'z-index: 1002; transition: all 0.5s ease-out;'}
	bind:clientHeight={headerHeight}
>
	<div class="flex flex-row gap-4 items-center grow justify-between md:justify-start">
		{#if $showReturn.length > 0}
			<button
				on:click={() => {
					routeToPage($showReturn);
					$showReturn = '';
				}}
			>
				<ArrowLeftIcon />
			</button>
		{:else}
			<div class="flex gap-4 items-center">
				<a href="https://www.facebook.com/boulangeriemadamepain/" target="_blank">
					<FacebookIcon />
				</a>
				<a
					href="https://www.instagram.com/boulangeriemadamepain/?igshid=MjAxZDBhZDhlNA%3D%3D"
					target="_blank"
				>
					<InstagramIcon />
				</a>

				<!-- <button
					class="w-10 h-10 p-4 rounded-lg bg-[#bb2528] flex items-center justify-center vibrate-1"
					on:click={() => (show = true)}
				>
					<iconify-icon class="text-white text-2xl" icon="icon-park-outline:christmas-tree" />
				</button> -->
			</div>
		{/if}
	</div>
	<span
		class="font-title text-3xl font-semibold flex items-center justify-center md:text-center text-right grow h-full"
	>
		<a class="cursor-pointer" href="/">Madame Pain</a>
	</span>
	{#if $store_screenWidth > smallScreen}
		<div class="flex flex-row items-center justify-end gap-4 text-xl">
			{#each headerItems as item}
				<div class="flex flex-row items-center gap-1">
					<button
						class="group"
						on:click={() => {
							routeToPage(item.link);
							scrollY.update((_) => 0);
						}}
					>
						{item.title}
						<span
							class="block max-w-0 group-hover:max-w-full transition-all duration-500 h-0.5"
							style={'background-color: ' + color + ';'}
						/>
					</button>
				</div>
			{/each}
		</div>
	{/if}
</div>

<NavMenu open={openMenu} />

<!-- <Noel bind:show /> -->

<style>
	.vibrate-1 {
		-webkit-animation: vibrate-1 1s linear infinite both;
		animation: vibrate-1 1s linear infinite both;
	}

	@-webkit-keyframes vibrate-1 {
		0% {
			-webkit-transform: translate(0);
			transform: translate(0);
		}
		20% {
			-webkit-transform: translate(-2px, 2px);
			transform: translate(-2px, 2px);
		}
		40% {
			-webkit-transform: translate(-2px, -2px);
			transform: translate(-2px, -2px);
		}
		60% {
			-webkit-transform: translate(2px, 2px);
			transform: translate(2px, 2px);
		}
		80% {
			-webkit-transform: translate(2px, -2px);
			transform: translate(2px, -2px);
		}
		100% {
			-webkit-transform: translate(0);
			transform: translate(0);
		}
	}
	@keyframes vibrate-1 {
		0% {
			-webkit-transform: translate(0);
			transform: translate(0);
		}
		20% {
			-webkit-transform: translate(-2px, 2px);
			transform: translate(-2px, 2px);
		}
		40% {
			-webkit-transform: translate(-2px, -2px);
			transform: translate(-2px, -2px);
		}
		60% {
			-webkit-transform: translate(2px, 2px);
			transform: translate(2px, 2px);
		}
		80% {
			-webkit-transform: translate(2px, -2px);
			transform: translate(2px, -2px);
		}
		100% {
			-webkit-transform: translate(0);
			transform: translate(0);
		}
	}
</style>
